#include <bindings.cmacros.h>
#include <apr_buckets.h>

BC_INLINE1VOID(APR_BRIGADE_CHECK_CONSISTENCY, apr_bucket_brigade*)
BC_INLINE1VOID(APR_BUCKET_CHECK_CONSISTENCY , apr_bucket*)

BC_INLINE1(APR_BRIGADE_SENTINEL, apr_bucket_brigade*, apr_bucket*)
BC_INLINE1(APR_BRIGADE_EMPTY   , apr_bucket_brigade*, int)
BC_INLINE1(APR_BRIGADE_FIRST   , apr_bucket_brigade*, apr_bucket*)
BC_INLINE1(APR_BRIGADE_LAST    , apr_bucket_brigade*, apr_bucket*)
BC_INLINE2VOID(APR_BRIGADE_INSERT_HEAD, apr_bucket_brigade*, apr_bucket*)
BC_INLINE2VOID(APR_BRIGADE_INSERT_TAIL, apr_bucket_brigade*, apr_bucket*)
BC_INLINE2VOID(APR_BRIGADE_CONCAT     , apr_bucket_brigade*, apr_bucket_brigade*)
BC_INLINE2VOID(APR_BRIGADE_PREPEND    , apr_bucket_brigade*, apr_bucket_brigade*)

BC_INLINE2VOID(APR_BUCKET_INSERT_BEFORE, apr_bucket*, apr_bucket*)
BC_INLINE2VOID(APR_BUCKET_INSERT_AFTER , apr_bucket*, apr_bucket*)
BC_INLINE1    (APR_BUCKET_NEXT         , apr_bucket*, apr_bucket*)
BC_INLINE1    (APR_BUCKET_PREV         , apr_bucket*, apr_bucket*)
BC_INLINE1VOID(APR_BUCKET_REMOVE       , apr_bucket*)
BC_INLINE1VOID(APR_BUCKET_INIT         , apr_bucket*)
BC_INLINE1    (APR_BUCKET_IS_METADATA  , apr_bucket*, int)
BC_INLINE1    (APR_BUCKET_IS_FLUSH     , apr_bucket*, int)
BC_INLINE1    (APR_BUCKET_IS_EOS       , apr_bucket*, int)
BC_INLINE1    (APR_BUCKET_IS_FILE      , apr_bucket*, int)
BC_INLINE1    (APR_BUCKET_IS_PIPE      , apr_bucket*, int)
BC_INLINE1    (APR_BUCKET_IS_SOCKET    , apr_bucket*, int)
BC_INLINE1    (APR_BUCKET_IS_HEAP      , apr_bucket*, int)
BC_INLINE1    (APR_BUCKET_IS_TRANSIENT , apr_bucket*, int)
BC_INLINE1    (APR_BUCKET_IS_IMMORTAL  , apr_bucket*, int)
#if APR_HAS_MMAP
  BC_INLINE1  (APR_BUCKET_IS_MMAP      , apr_bucket*, int)
#endif
BC_INLINE1    (APR_BUCKET_IS_POOL      , apr_bucket*, int)

BC_INLINE1VOID(apr_bucket_destroy , apr_bucket*)
BC_INLINE1VOID(apr_bucket_delete  , apr_bucket*)
BC_INLINE4    (apr_bucket_read    , apr_bucket*, const char**, apr_size_t*, apr_read_type_e, apr_status_t)
BC_INLINE2    (apr_bucket_setaside, apr_bucket*, apr_pool_t*, apr_status_t)
BC_INLINE2    (apr_bucket_split   , apr_bucket*, apr_size_t, apr_status_t)
BC_INLINE2    (apr_bucket_copy    , apr_bucket*, apr_bucket**, apr_status_t)
